
##################################################################
#
# Do not edit this file! File generated by inc2py.py utility.
#


##################################################################
#
# Author:  Kurt W Dekker
# Date:    January 14, 2007
#
# Python Super-Stupid Space Invaders
#
# PySSSI is borne... gotta get comfortable with Python next!
#
# This needs Python 2.4 and Pygame 1.7. Use google my friend!
#


##################################################################
import pygame
from pygame.constants import *

import random


##################################################################
# preferences
screen_size = (640,480)


##################################################################
pygame.init()
global fullscreen
fullscreen=False

scrnflags = 0
if fullscreen: scrnflags = pygame.FULLSCREEN
global screen
screen = pygame.display.set_mode(screen_size, scrnflags)

pygame.mouse.set_visible(True)
clock = pygame.time.Clock()
prevkeybits = []
keybits = []



##################################################################
# This is part of Kurt Dekker's common python library codebase.
#
# These are some basic data-loading functions I've found in various
# places on the net and incorporated here.

##################################################################
def	datapath_art(file):
	return "data/art/" + file
def	datapath_sound(file):
	return "data/sound/" + file


##################################################################
#taken from livewires
def load_image(file, transparent=1):
	"""
	file -- the filename of the image to load
	transparent -- whether the background of the image should be transparent.
				   Defaults to true.
				   The background colour is taken as the colour of the pixel
				   at (0,0) in the image.
	"""
	surface = pygame.image.load(datapath_art(file))
	if transparent:
		corner = surface.get_at((0, 0))
		surface.set_colorkey(corner, RLEACCEL)
	return surface		#.convert

def load_sound(file):
	"""
	Load a sound file, returning a Sound object.
	"""
	return pygame.mixer.Sound(datapath_sound(file))




##################################################################
# This is part of Kurt Dekker's common python library codebase.
#
# Shapestrips are convenient ways of storing related same-sized
# small graphical pieces, such as animations.

##################################################################
class shapestrip:
	def	__init__(self,file,ysize):
		self.shape = load_image( file)
		self.xsize = self.shape.get_width()
		self.ysize = ysize
	def	plot(self,x,y,frameno):
		dst = [x - self.xsize / 2, y - self.ysize / 2,0,0]
		src = [0, frameno * self.ysize, self.xsize, self.ysize]
		screen.blit( self.shape, dst, src)


##################################################################
# This is part of Kurt Dekker's common python library codebase.
#
# This wraps the font/printing stuff in a way that is useful to me.
#

##################################################################
JUSTIFY_LEFT   = 0x0000
JUSTIFY_CENTER = 0x0001
JUSTIFY_RIGHT  = 0x0002

class	_vgaprn:
	def __init__(self):
		self.print_font = pygame.font.SysFont("Times New Roman",30)
		self.color0 = (0,0,0)
		self.color1 = (255,255,255)
		self.zerowrite = 0
		self.justify = 0
	def	printf(self,x,y,str):
		if self.print_font:
			s = self.print_font.render( str,False,self.color1)
			if self.justify & JUSTIFY_CENTER:
				x -= s.get_width() / 2
			elif self.justify & JUSTIFY_RIGHT:
				x -= s.get_width()
			if self.zerowrite:
				pygame.draw.rect( screen, self.color0, (x,y,s.get_width(),s.get_height()))
			screen.blit( s, (x, y))
		return			

VGAPRN = _vgaprn()


##################################################################
# the basic plot-a-bitmap function (blit) based on the shape center
def	plot( x, y, shape):
	r = [x - shape.get_width() / 2,y - shape.get_height() / 2,0,0]
	screen.blit( shape, r)
	return


##################################################################
# someday this will be rolled into a general purpose canvas manager...
CANVAS_GREET    =  1
CANVAS_INITGAME =  2
CANVAS_INITWAVE =  3
CANVAS_PLAYING  =  4
CANVAS_MAXIMUM  =  5


##################################################################

##################################################################
# static data
your_ship = load_image( "your_ship.png")
your_ship_iconic = load_image( "your_ship_iconic.png")

ss_shots_and_bombs = shapestrip( "shots_and_bombs.png", 25)

ss_expl1 = shapestrip( "expl1.png", 18)
ss_expl2 = shapestrip( "expl2.png", 25)

ss_invaders = shapestrip( "invaders.png", 25)

ss_saucer1 = shapestrip( "saucer1.png", 15)


##################################################################
sounds_shots = []
sounds_shots.append( load_sound( "shot1.wav"))
sounds_shots.append( load_sound( "shot2.wav"))
sounds_shots.append( load_sound( "shot3.wav"))

sounds_expls = []
sounds_expls.append( load_sound( "expl1.wav"))
sounds_expls.append( load_sound( "expl2.wav"))
sounds_expls.append( load_sound( "expl3.wav"))
sounds_expls.append( load_sound( "expl4.wav"))
sounds_expls.append( load_sound( "expl5.wav"))
sounds_expls.append( load_sound( "expl6.wav"))

sounds_bombs = []
sounds_bombs.append( load_sound( "bomb1.wav"))

sound_saucer1 = load_sound( "saucer1.wav")

def	sound_silence_all():
	sound_saucer1.stop()
	return

##################################################################
# game data... I envision a STATE class instantiated here that has it all
class	OBJ:
	def __init__(self):
		# status
		self.flag = 0
		self.dead = 0
		self.type = 0
		self.subtype = 0
		# timers, counters, etc
		self.timer = 0
		self.state = 0
		# fixed point
		self.x = 0
		self.y = 0
		self.xm = 0
		self.ym = 0
		# integer (screen coords generally)
		self.ix = 0
		self.iy = 0
		self.r = pygame.Rect(0,0,0,0)
		# appearance
		self.frameno = 0
		self.animseq = 0
		# misc
		self.gunheat = 0
		return
	def	calcrect(self,w,h):
		self.ix = self.x >> 16
		self.iy = self.y >> 16
		self.r.x = self.ix - w / 2
		self.r.y = self.iy - h / 2
		self.r.w = w
		self.r.h = h
		return


##################################################################
class	gamestate:
	def	__init__(self):
		self.score = 0
		self.highscore = 0		# read it from a file someday...
		self.ships = 0		# lives
		self.wave = 0

		self.canvasno = 0
		self.canvastimer = 0

		self.you = OBJ()
		self.shots = []
		self.bombs = []
		self.expls = []
		self.saucers = []
		self.invaders = []
		self.invaders_rover = 0
		self.invaders_speed = 5
		self.invaders_xm_basic = 0		# the "notional" speed the field wants
		self.invaders_ym_basic = 0
		self.invaders_xm = 0			# the actual speeds the field is going now
		self.invaders_ym = 0
		self.invaders_tempxm = 0		# stores the previous direction during descent
		self.invaders_phase = 0		# 0-normal, 1-needing to descend, 2-descending
		self.invaders_pause = 0			# when any are shot, the invader field freezes
		self.invaders_exterminated = 0	# counts up, reset to zero by ANY invader presence, used to start new wave
		self.invaders_have_landed = 0	# the game is over my friend

		self.saucer_appearance_counter = 0	# counts up to appearance of a saucer
		self.difficulty_cursaucers = 0		# how many saucers on right now?
		self.difficulty_maxsaucers = 0		# how many saucers maximum?

		self.difficulty_curbombs = 0	# how many bombs airborne right now?
		self.difficulty_maxbombs = 0	# how many bombs maximum?
		self.difficulty_curshots = 0
		self.difficulty_maxshots = 0	# how many shots maximum?

		return

# herein lies the entire "state" of the game (not including static asset data)
STATE = gamestate()

hisc_filename = "pysssi_highscore.txt"

try:
	hiscfile = open( hisc_filename, "rt")
	try:
		STATE.highscore = int( hiscfile.read())
	except ValueError:
		pass
	hiscfile.close()
except IOError:
	pass

# I'm putting in a high score "floor." Gotta beat this...
if STATE.highscore < 1000:
	STATE.highscore = 1000

\
##################################################################
# Author: Kurt Dekker
# Date: January 23, 2007
# Inits for the PySSSI project
#

##################################################################
# inits of various kinds...
def	init_initgame():
	STATE.score = 0
	STATE.ships = 3
	STATE.wave = 0
	STATE.you.__init__()
	aliens_clearall()
	STATE.invaders_have_landed = 0
	return

def	init_initwave():
	STATE.wave = STATE.wave + 1
	# kill off and add you back into ships, if alive
	if STATE.you.flag:
		STATE.you.__init__()
		STATE.ships += 1
# not necessary: lets saucers "linger"
#	aliens_clearall()
	STATE.invaders = []
	bombs_clearall()
	shots_clearall()
	expls_clearall()
	# what are the notional speeds of aliens?
	STATE.invaders_xm_basic = 5 << 16		# across
	STATE.invaders_ym_basic = 15 << 16		# down

	STATE.invaders_xm = STATE.invaders_xm_basic
	STATE.invaders_ym = 0

	STATE.invaders_pause = 0
	STATE.invaders_exterminated = 0

	# ramp these invader field values up with each wave
	lowest_alien_row = 100 + 50 * STATE.wave
	# but don't let it get INSANELY low... (well, this is pretty damned low!)
	if lowest_alien_row > screen.get_height() - 100:
		lowest_alien_row = screen.get_height() - 100

	invaders_across = 7 + ((STATE.wave - 1) & 3)
	invaders_down   = 4 + ((STATE.wave - 1) & 3)

	for j in range( invaders_down):
		for i in range( invaders_across):
			a = invaders_alloc()
			if a:
				a.flag = 1
				a.type = j
				a.x = (150 + i * 40) << 16
				a.y = (lowest_alien_row - j * 30) << 16
				a.calcrect( 30, 20)
				a.frameno = (a.type & 3) * 2

	# ramp these various difficulty values up with each wave!
	STATE.difficulty_maxbombs = 4 + STATE.wave
	STATE.difficulty_maxshots = 1 + STATE.wave
	
	# more than about 4 shots is just a silly slaughterfest... but please, help yourself!
	if STATE.difficulty_maxshots > 4:
		STATE.difficulty_maxshots = 4

	STATE.saucer_appearance_counter = 0
	STATE.difficulty_maxsaucers = 1

	return

##################################################################
def	canvas_greet():
	c = [80,0,0]
	screen.fill( c)

	if STATE.score > STATE.highscore:
		STATE.highscore = STATE.score
		try:
			hiscfile = open( hisc_filename, "wt")
			hiscfile.write( str( STATE.highscore))
			hiscfile.close()
		except IOError:
			pass


	VGAPRN.zerowrite = 0
	VGAPRN.color1 = (255, 255, 0)
	VGAPRN.justify = JUSTIFY_CENTER

	nn = 9		# cheesy line spacing onscreen
	VGAPRN.printf( screen_size[0] / 2, 1 * screen_size[1] / nn,
					"Python Super Stupid Space Invaders!")
	VGAPRN.printf( screen_size[0] / 2, 2 * screen_size[1] / nn,
					"By Kurt W Dekker for PLBM Games")
	VGAPRN.printf( screen_size[0] / 2, 3 * screen_size[1] / nn,
					"http://www.plbm.com");
	VGAPRN.printf( screen_size[0] / 2, 4 * screen_size[1] / nn,
					"Press <ENTER> to begin new game");
	tmp = "Last: " + `STATE.score` + " --- High: " + `STATE.highscore`
	VGAPRN.printf( screen_size[0] / 2, 5 * screen_size[1] / nn,
					tmp);
	VGAPRN.printf( screen_size[0] / 2, 6 * screen_size[1] / nn,
					"Use arrows to move and Ctrl to fire")
	VGAPRN.printf( screen_size[0] / 2, 7 * screen_size[1] / nn,
					"ESCAPE to exit and <F> to toggle Fullscreen")

	return

EXPLTYPE_EXPL1 = 101
EXPLTYPE_EXPL2 = 102

##################################################################
def	expls_clearall():
	STATE.expls = []
	return

def	expls_alloc():
	for e in STATE.expls:
		if e:
			if e.flag == 0:
				e.__init__()
				return e
	e = OBJ()
	STATE.expls.append(e)
	return e

def	expls_think():
	for e in STATE.expls:
		if e:
			if e.flag:
				if e.type == EXPLTYPE_EXPL1:
					e.animseq += 1
					e.frameno = e.animseq - 1
					if e.animseq >= 10:
						e.flag = 0
				if e.type == EXPLTYPE_EXPL2:
					e.timer -= 1
					if e.timer <= 0:
						e.flag = 0
				e.calcrect( 0,0)
	return

def	expls_paint():
	for e in STATE.expls:
		if e:
			if e.flag:
				if e.type == EXPLTYPE_EXPL1:
					ss_expl1.plot( e.ix, e.iy, e.frameno)
				if e.type == EXPLTYPE_EXPL2:
					ss_expl2.plot( e.ix, e.iy, 0)
	return

##################################################################
def	shots_clearall():
	STATE.shots = []
	return

def	shots_alloc():
	for s in STATE.shots:
		if s:
			if s.flag == 0:
				s.__init__()
				return s
	s = OBJ()
	STATE.shots.append(s)
	return s

def	shots_think():
	for s in STATE.shots:
		if s:
			if s.flag:
				## <WIP> this should support different types of shots!
				s.x += s.xm
				s.y += s.ym
				s.calcrect( 10, 20)
				if aliens_check_shot(s):
					s.flag = 0
					sounds_expls[random.randrange(len(sounds_expls))].play()
				if s.iy < -20:
					s.flag = 0
	return

def	shots_paint():
	numshots = 0
	for s in STATE.shots:
		if s:
			if s.flag:
				## <WIP> this should support different types of shots!
				ss_shots_and_bombs.plot( s.ix, s.iy, 0)
				numshots += 1

	STATE.difficulty_curshots = numshots

	return

##################################################################
def	bombs_clearall():
	STATE.bombs = []
	return

def	bombs_alloc():
	for b in STATE.bombs:
		if b:
			if b.flag == 0:
				b.__init__()
				return b
	b = OBJ()
	STATE.bombs.append(b)
	return b

def	bombs_think():
	for b in STATE.bombs:
		if b:
			if b.flag:
				## <WIP> this should support different types of bombs!
				b.x += b.xm
				b.y += b.ym
				b.calcrect( 10, 20)
				# see if we hit the player
				if STATE.you.flag:
					if STATE.you.dead == 0:
						if abs( STATE.you.ix - b.ix) < 26:
							if abs( STATE.you.iy - b.iy) < 20:
								STATE.you.dead = 1
								b.flag = 0
				# see if we fell off the bottom
				if b.iy > screen.get_height() - 35:
					b.flag = 0
					e = expls_alloc()
					# make a little shot explosion here?
					if e:
						e.flag = 1
						e.type = EXPLTYPE_EXPL1
						e.x = b.x
						e.y = (screen.get_height() - 30) << 16
						e.calcrect( 0,0)
	return

def	bombs_paint():
	numbombs = 0
	for b in STATE.bombs:
		if b:
			if b.flag:
				## <WIP> this should support different types of bombs!
				ss_shots_and_bombs.plot( b.ix, b.iy, 3)
				numbombs += 1

	STATE.difficulty_curbombs = numbombs

	return

##################################################################
# how many pixels from edge do we trigger a turn-back?
INVADER_EDGEX = 30


##################################################################
def	aliens_clearall():
	STATE.invaders = []
	STATE.invaders_rover = 0
	STATE.saucers = []
	sound_saucer1.stop()
	return

def	saucers_alloc():
	for a in STATE.saucers:
		if a:
			if a.flag == 0:
				a.__init__()
				return a
	a = OBJ()
	STATE.saucers.append(a)
	return a

def	invaders_alloc():
	for a in STATE.invaders:
		if a:
			if a.flag == 0:
				a.__init__()
				return a
	a = OBJ()
	STATE.invaders.append(a)
	return a

def	aliens_think_one_invader():
	deadlock = 0		# keep us from indefinitely spinning when all aliens killed off!
	if not len( STATE.invaders): return
	while 1:
		if STATE.invaders_rover == 0:
			# any turning-and-descending needed?
			if STATE.invaders_phase == 1:
				STATE.invaders_tempxm = STATE.invaders_xm
				STATE.invaders_xm = 0
				STATE.invaders_ym = STATE.invaders_ym_basic
				STATE.invaders_phase = 2
			elif STATE.invaders_phase == 2:
				STATE.invaders_xm = -STATE.invaders_tempxm	# turn back
				STATE.invaders_ym = 0
				STATE.invaders_phase = 0
		a = STATE.invaders[ STATE.invaders_rover]
		STATE.invaders_rover += 1
		if STATE.invaders_rover >= len(STATE.invaders):
			STATE.invaders_rover = 0
			if deadlock >= 2:
				return
			deadlock += 1
		if a:
			if a.flag:
				STATE.invaders_exterminated = 0		# I'm not dead yet!!
				a.x += STATE.invaders_xm
				a.y += STATE.invaders_ym
				a.calcrect( 30, 20)
				# check for landing on the planet!!
				if a.iy >= STATE.you.iy - 25:
					a.iy = STATE.you.iy
					a.y = a.iy << 16
					STATE.invaders_have_landed = 1
					STATE.you.dead = 1		# force you through a full death sequence
					STATE.ships = 0			# remove ALL your ships - it's over man!!

				# check for turning back at edges
				if (a.ix < INVADER_EDGEX) or (a.ix > screen.get_width() - INVADER_EDGEX):
					if STATE.invaders_phase == 0:
						STATE.invaders_phase = 1		# initiate descent and turn after this
				a.animseq += 1
				a.frameno = (a.type & 3) * 2 + (a.animseq & 1)

				if STATE.difficulty_curbombs < STATE.difficulty_maxbombs:
					if random.randrange(100) == 0:
						b = bombs_alloc()
						if b:
							b.flag = 1
							b.x = a.x
							b.y = a.y
							b.xm = 0
							b.ym = 5 << 16
							b.calcrect( 0,0)
							sounds_bombs[random.randrange(len(sounds_bombs))].play()
				break
	return

def	aliens_think_invaders():
	if STATE.invaders_have_landed:
		return
	# when the invaders lose one of their kin, they pause momentarily
	if STATE.invaders_pause > 0:
		STATE.invaders_pause -= 1
		return
	STATE.invaders_pause = 0
	# when you are dying the invaders are gentlemanly and hover for a bit
	if STATE.you.dead:
		return
	for a in range( STATE.invaders_speed):
		aliens_think_one_invader()
	STATE.invaders_exterminated += 1
	if STATE.invaders_exterminated > 50:
		STATE.canvasno = CANVAS_INITWAVE
	return

def	aliens_think_saucers():
	numsaucers = 0
	for a in STATE.saucers:
		if a:
			if a.flag:
				numsaucers += 1
				# this is only used for saucers just now...
				a.x += a.xm
				a.y += a.ym
				a.calcrect( 40, 20)
				if a.xm > 0:
					if a.ix >= screen.get_width() + 30:
						a.flag = 0
						sound_saucer1.stop()
				if a.xm < 0:
					if a.ix <= -30:
						a.flag = 0
						sound_saucer1.stop()
	STATE.difficulty_cursaucers = numsaucers


def	aliens_think():
	aliens_think_invaders()
	aliens_think_saucers()

	if STATE.invaders_have_landed:
		return

	# time for a new saucer mayhaps??
	if STATE.difficulty_cursaucers < STATE.difficulty_maxsaucers:
		STATE.saucer_appearance_counter += 1
		if STATE.saucer_appearance_counter > 300:
			STATE.saucer_appearance_counter = 0
			a = saucers_alloc()
			if a:
				a.flag = 1
				a.y = 20 << 16
				if random.randrange(2) == 0:
					a.x = -30 << 16
					a.xm = (2 + random.randrange(2)) << 16
				else:
					a.x = (screen.get_width() + 30) << 16
					a.xm = -(2 + random.randrange(2)) << 16
				a.calcrect( 0,0)
				sound_saucer1.play(-1)

def	aliens_paint():
	for a in STATE.invaders:
		if a:
			if a.flag:
				ss_invaders.plot( a.ix, a.iy, a.frameno)
	for a in STATE.saucers:
		if a:
			if a.flag:
				ss_saucer1.plot( a.ix, a.iy, 0)
	if STATE.invaders_have_landed:
		VGAPRN.zerowrite = 0
		VGAPRN.color1 = (random.randrange( 256), random.randrange( 256), random.randrange(256))
		VGAPRN.justify = JUSTIFY_CENTER
		VGAPRN.printf( screen.get_width() / 2, screen.get_height() / 3,
						"*** YOU HAVE BEEN INVADED ***")
	return

def	aliens_check_shot(s):
	for a in STATE.saucers:
		if a:
			if a.flag:
				if abs( a.ix - s.ix) < ( a.r.w + s.r.w) / 2:
					if abs( a.iy - s.iy) < ( a.r.h + s.r.h) / 2:
						a.flag = 0
						STATE.score += 100 * (1 + random.randrange( 9))
						sound_saucer1.stop()
						sounds_expls[random.randrange(len(sounds_expls))].play()
						# make a little explosion here!
						e = expls_alloc()
						if e:
							e.flag = 1
							e.type = EXPLTYPE_EXPL2
							e.timer = 10
							e.x = a.x
							e.y = a.y
							e.calcrect( 0,0)

	for a in STATE.invaders:
		if a:
			if a.flag:
				if abs( a.ix - s.ix) < ( a.r.w + s.r.w) / 2:
					if abs( a.iy - s.iy) < ( a.r.h + s.r.h) / 2:
						a.flag = 0
						STATE.score += 10 * (1 + a.type) + 5 * STATE.wave
						# everybody just pause for a second...
						# we lost one of our buddies!
						STATE.invaders_pause = 5
						# make a little explosion here!
						e = expls_alloc()
						if e:
							e.flag = 1
							e.type = EXPLTYPE_EXPL2
							e.timer = 10
							e.x = a.x
							e.y = a.y
							e.calcrect( 0,0)
						return 1
	return 0


##################################################################
# how far do we keep you from the edges?
YOU_EDGEX = 50

##################################################################
def	you_think():
	if STATE.you.flag == 0:
		if STATE.ships > 0:
			STATE.ships -= 1
			
			STATE.you.flag = 1
			STATE.you.dead = 0

			STATE.you.x = YOU_EDGEX << 16
			STATE.you.y = (screen.get_height() - 40) << 16

			STATE.you.calcrect( 0,0)
		else:
			sound_silence_all()
			STATE.canvasno = CANVAS_GREET

	if STATE.you.dead > 0:
		STATE.you.dead += 1
		if STATE.you.dead > 80:
			STATE.you.flag = 0
			return
		e = expls_alloc()
		if e:
			e.flag = 1
			e.type = EXPLTYPE_EXPL1
			e.x = STATE.you.x + ((random.randrange( 40) - 20) << 16)
			e.y = STATE.you.y + ((random.randrange( 16) -  8) << 16)
			e.calcrect( 0,0)
			if (STATE.you.dead & 3) == 0:
				sounds_expls[random.randrange(len(sounds_expls))].play()
		return

	STATE.you.xm = 0
	STATE.you.ym = 0

	if STATE.you.gunheat > 0:
		STATE.you.gunheat -= 1

	if keybits[ K_LCTRL] or keybits[ K_RCTRL]:
		if (STATE.you.gunheat == 0) or (not (prevkeybits[ K_LCTRL] or prevkeybits[ K_RCTRL])):
			if STATE.difficulty_curshots < STATE.difficulty_maxshots:
				s = shots_alloc()
				if s:
					s.flag = 1
					s.x = STATE.you.x
					s.y = STATE.you.y
					s.xm = 0
					s.ym = -10 << 16
					s.calcrect( 0,0)
					STATE.you.gunheat = 5		# firerate
					sounds_shots[random.randrange(len(sounds_shots))].play()

	if keybits[ K_LEFT]:
		STATE.you.xm = -5 << 16

	if keybits[ K_RIGHT]:
		STATE.you.xm =  5 << 16

	STATE.you.x += STATE.you.xm
	STATE.you.y += STATE.you.ym

	if STATE.you.x < YOU_EDGEX << 16:
		STATE.you.x = YOU_EDGEX << 16
	if STATE.you.x > (screen.get_width() - YOU_EDGEX) << 16:
		STATE.you.x = (screen.get_width() - YOU_EDGEX) << 16

	STATE.you.calcrect( 30, 40)

	return

def	you_paint():
	if STATE.you.flag:
		if STATE.you.dead == 0:
			plot( STATE.you.ix, STATE.you.iy, your_ship)
	return

##################################################################
joyinitted = 0
joystick1 = 0
joydot = 0

##################################################################
def joystick_test():
	global joystick1, joyinitted, joydot
	if not joyinitted:
		joyinitted = 1
		try:
			joystick1 = pygame.joystick.Joystick(0)
		except pygame.error:
			joystick1 = 0
			return
	if not joystick1:
		return
	if not joydot:
		joydot = load_image( "joydot.png")
	joystick1.init()
	jx1 = 0
	jy1 = 0
	jx2 = 0
	jy2 = 0
	for i in range( joystick1.get_numaxes()):
		xxx = joystick1.get_axis(i)
		xxx = 200 + 100 * xxx
		if i == 0: jx1 = xxx
		if i == 1: jy1 = xxx
		if i == 2: jx2 = xxx
		if i == 3: jy2 = xxx
	plot( jx1, jy1, joydot)
	plot( jx2, jy2, joydot)
	return


##################################################################
def	canvas_playing():
	screen.fill((0,0,0))

	pygame.draw.rect( screen, [255, 255, 255], [0, screen.get_height() - 27, screen.get_width(), 5])

	for i in range( STATE.ships):
		plot( 15 + i * 27, screen.get_height() - 10, your_ship_iconic)

	VGAPRN.zerowrite = 0
	VGAPRN.color1 = ( 200,200,200)
	VGAPRN.justify = JUSTIFY_LEFT
	VGAPRN.printf( 5, 5, `STATE.score`);

	you_think()
	shots_think()
	aliens_think()
	bombs_think()
	expls_think()

	you_paint()
	shots_paint()
	bombs_paint()
	aliens_paint()
	expls_paint()

	joystick_test()

	return


##################################################################
def	dispatch_canvases():
	STATE.canvastimer += 1
	if STATE.canvasno == CANVAS_GREET:
		canvas_greet()
	elif STATE.canvasno == CANVAS_INITGAME:
		init_initgame()
		STATE.canvasno = STATE.canvasno + 1
	elif STATE.canvasno == CANVAS_INITWAVE:
		init_initwave()
		STATE.canvasno = STATE.canvasno + 1
	elif STATE.canvasno == CANVAS_PLAYING:
		canvas_playing()
	else:
		STATE.canvasno = STATE.canvasno + 1
		if STATE.canvasno >= CANVAS_MAXIMUM:
			STATE.canvasno = CANVAS_GREET


##################################################################
finished = False
while not finished:

	prevkeybits = keybits[:]
	keybits = pygame.key.get_pressed()

	for e in pygame.event.get():
		if e.type == pygame.KEYDOWN:

#cheat to skip to next level
#			if e.key == pygame.K_n:
#				aliens_clearall()
#				STATE.canvasno = CANVAS_INITWAVE

			if e.key == pygame.K_f:
				if not fullscreen:
					screen=pygame.display.set_mode((640,480),pygame.FULLSCREEN)
					fullscreen=True
					pygame.mouse.set_visible(False)
				else:
					pygame.mouse.set_visible(True)
					screen=pygame.display.set_mode((640,480))
					fullscreen=False
			if e.key == K_ESCAPE:
				if STATE.canvasno == CANVAS_GREET:
					finished = True
				else:
					sound_silence_all()
					STATE.canvasno = CANVAS_GREET
				break

			## this logic belongs INSIDE the greet canvas...
			if e.key == K_RETURN:
				if STATE.canvasno == CANVAS_GREET:
					STATE.canvasno = CANVAS_INITGAME

		if e.type in (pygame.QUIT, pygame.MOUSEBUTTONDOWN):
			finished = True
			break

	dispatch_canvases()

	pygame.display.update()

	clock.tick(30)
